{$F+}
uses Dos,Crt,HexaDeci,Inflate,CRC32___;

var SaveExit:pointer;
    ExitStatus:longint;

procedure ExitProcedure;
begin
  ExitProc:=SaveExit;
  if ExitCode<>0 then begin
    writeln;
    if ExitStatus=0 then begin
      writeln('  Error caused by inflate.pas (check readme.txt)');
    end else writeln('  Error caused by hwun.pas (please do bugreport)');
  end;
end;

const HWUN_Version:word=$040a;
      DateStr:string[10]='2001-12-25';
      WSizee:word=$8000;
      DispDebug:boolean=FALSE;

var rollback,useroffset:longint;
    finetune,renaming:boolean;

type tAOB=Array [$0000..$fffe] of byte;

var InflateVars:record
                  F1,F2:file;
                  Buf:^tAOB;
                  BufSize,BufLength:longint;
                  BufPos:longint;
                  F1Pos:longint;
                  F1Length:longint;
                  F2Pos:longint;
                  F2Length:longint;
                  CRC32:longint;
                  InflateResult:longint;
                end;

var readbeforewrite:boolean;

function InflateReadProc:byte; far;
begin
  readbeforewrite:=TRUE;
  InflateReadProc:=InflateVars.Buf^[InflateVars.BufPos];
  inc(InflateVars.F1Pos);
  inc(InflateVars.BufPos);
  if (InflateVars.BufPos=InflateVars.BufLength) then with InflateVars do begin
    BufLength:=F1Length-F1Pos;
    if BufLength>BufSize then BufLength:=BufSize;
    BufPos:=$0000;
    seek(F1,F1POS);
    blockread(F1,Buf^,BufLength);
  end;
end;

const waitstr:array [$00..$03] of char='-\|/';
var waitind:byte;

function InflateFlushProc(W:word):smallint; far;
var l:longint;
    c:longint;
begin
  if readbeforewrite then begin
  blockwrite(InflateVars.F2,Slide^,w);
  if w>0 then CRCAddBuffer(InflateVars.CRC32,Slide^,w);
  inc(InflateVars.F2Pos,w);
  inc(waitind);
  if waitind mod $02=$00 then begin
    write(waitstr[(waitind div $02) mod $04]);
    l:=trunc(InflateVars.F1Pos/InflateVars.F1Length*100);
    c:=trunc(InflateVars.F1Pos/InflateVars.F1Length*10000) mod 100;
    write(' ',l:3,'.',c div 10,c mod 10,'%'); gotoxy(wherex-9,wherey);
  end;
  InflateFlushProc:=0;
  end else InflateFlushProc:=1;
  readbeforewrite:=FALSE;
end;

function InitializeInflate(S1,S2:String; Offset:LongInt):byte;
begin
  with InflateVars do begin
    CRCStart(CRC32);
    BufSize:=$8000;
    getmem(Buf,BufSize);
    getmem(Slide,WSizee);
    InflateRead:=InflateReadProc;
    InflateFlush:=InflateFlushProc;
    assign(F1,S1);
    assign(F2,S2);
    {$I-} reset(F1,1); {$I+}
    if IoResult=0 then begin
      rewrite(F2,1);
      F1Length:=filesize(F1);
      F1Pos:=Offset;
      F2Length:=0;
      F2Pos:=0;
      BufLength:=F1Length-F1Pos;
      if BufLength>BufSize then BufLength:=BufSize;
      BufPos:=$0000;
      seek(F1,F1Pos);
      blockread(F1,Buf^,BufLength);
      InflateResult:=$00;
    end else begin
      freemem(Slide,WSizee);
      freemem(Buf,BufSize);
      InflateResult:=$fd;
      close(F1);
      close(F2);
    end;
  end;
end;

procedure dummy;
var l,l1:longint;
begin
  for l:=0 to 1000 do l1:=l1*l;
  write('!');
end;

procedure ExecuteInflate;
var l:longint;
begin
  with InflateVars do begin
    InflateResult:=InflateRun;
    freemem(Buf,BufSize);
    freemem(Slide,WSizee);
    close(F1);
    close(F2);
    F2Length:=F2Pos;
    CRCEnd(CRC32);
  end;
end;

var ArchiveVars:record
      { 00 = ofs in ApprArcOfs, ff = error }
      ApprArcResult:byte;
      ApprArcOfs:longint;
      { 00 = DLL, 01 = Bitmap, 02 = Script, fe = Unknown, ff = Error }
      TestInflateResult:byte;
      RealArcResult:byte;
      { 00 = ofs in RealArcOfs, ff = not found }
      RealArcOfs:longint;
    end;

procedure TestInflate(S1:string; Offset:longint);
const TempName:string[11]='C:\HWUNTMP0';
const BufferSize:word=$8000;
var TempFile:file;
    Buffer:^tAOB;
    Pos,Post:longint;
    Test:boolean;
begin
  with InflateVars do begin
    InitializeInflate(S1,TempName,Offset);
    if InflateResult=0 then ExecuteInflate;
    if InflateResult<>0 then ArchiveVars.TestInflateResult:=$ff else begin
      assign(TempFile,TempName);
      reset(TempFile,1);
      getmem(Buffer,BufferSize);
      fillchar(Buffer^,BufferSize,$ff);
      if filesize(TempFile)>BufferSize then blockread(TempFile,Buffer^,BufferSize)
                                       else blockread(TempFile,Buffer^,filesize(TempFile));
      { Test if it is a bitmap file (splashscreen) by checking dimensions
        for being lower than 16 million pixels and checking palette entries
        to be valid (every fourth byte in palette is unused and set to 00h }
      Test:=TRUE;
      for Pos:=$00 to $17 do Test:=Test and (Buffer^[Pos*$04+$03]=$00);
      if Test then ArchiveVars.TestInflateResult:=$01 else begin
        { Test if it is a DLL file (wise????.dll) by "MZ"-signature check }
        Test:=TRUE;
        Test:=Test and (Buffer^[0]=$4d{"M"});
        Test:=Test and (Buffer^[1]=$5a{"Z"});
        if Test then ArchiveVars.TestInflateResult:=$00 else begin
          { Test if it is a WISE script file by searching for the first
            file being installed on a variable path like %MAINDIR%\????,
            by checking for one "%" and one "%\" }
          Test:=FALSE;
          Pos:=$00;
          while (Pos<BufferSize) and (not Test) do begin
            inc(Pos);
            Test:=TRUE;
            if Test then Test:=Buffer^[Pos+$00]=$25{"%"};
            if Test then Test:=Buffer^[Pos+$01]<>$5c{"\"};
            if Test then begin
              Post:=$01;
              while (Post+Pos<BufferSize) and (Buffer^[Pos+Post]<>$25) and (Post<$10) do inc(Post);
              Test:=(Post<$10) and (Buffer^[Pos+Post+$01]=$5c{"\"});
            end;
          end;
          if Test then ArchiveVars.TestInflateResult:=$02 else ArchiveVars.TestInflateResult:=$fe;
        end;
      end;
      close(TempFile);
      erase(TempFile);
      freemem(Buffer,BufferSize);
    end;
  end;
end;

(*--OLD-ONE---
procedure ApprArc(S1:string);
const Start:longint=$00002800;
      BufferSize:word=$c000;
var F:file;
    FS:longint;
    Buffer:^tAOB;
    BufferLen:longint;
    Pos,Post,Avg,Zero:longint;
    Test1,Test2:boolean;
begin
  assign(F,S1);
  {$I-} reset(F,1); {$I+}
  if IoResult<>0 then ArchiveVars.ApprArcResult:=$ff else begin
    FS:=filesize(F);
    getmem(Buffer,BufferSize);
    fillchar(Buffer^,BufferSize,$00);
    if FS<Start+$800 then ArchiveVars.ApprArcResult:=$ff else begin
      ArchiveVars.ApprArcResult:=$ff;
      seek(F,Start);
      if FS-Start<BufferSize then BufferLen:=FS-Start else BufferLen:=BufferSize;
      blockread(F,Buffer^,BufferLen);
      Test1:=FALSE;
      Test2:=Test1;
      for Pos:=$0000 to BufferLen-$0801 do begin
        Avg:=$00;
        Zero:=Avg;
        for Post:=$0000 to $07ff do Avg:=Avg+Buffer^[Pos+Post];
        for Post:=$0000 to $007f do if Buffer^[Pos+Post]=$00 then inc(Zero);
        Avg:=Avg shr $0b;
        if (not Test1) then Test1:=(not Test2) and (Avg<$40);
        if (not Test2) then Test2:=(Test1) and (Zero<$04) and (Avg>$3f) and (Avg<$b1);
        if Test2 then ArchiveVars.ApprArcOfs:=Pos+Start;
        if Test2 then ArchiveVars.ApprArcResult:=$00;
        if Test2 then Pos:=BufferLen-$0801;
      end;
    end;
    freemem(Buffer,BufferSize);
    close(F);
  end;
end;*)

procedure ApprArc(S1:string);
type buft=array[$0000..$bfff] of byte;
var F:file;
    BUF:^buft;
    Diff,NullCount,Average,C0,C1,C2,C3,R1:longint;
    L1,L2,L3:longint;
begin
  new(BUF);
  assign(F,S1);
  {$I-} reset(F,1); {$I+}
  if IoResult<>0 then begin
    ArchiveVars.ApprArcResult:=$ff;
  end else if filesize(F)>=$c000 then begin
    blockread(F,BUF^,$c000);
    L1:=$bfe0;
    R1:=0;
    while (R1=0) and (L1>=0) do begin
      NullCount:=0; Average:=0; C0:=0; C1:=0; C2:=0; C3:=0;
      Diff:=0;
      for L2:=$0000 to $001f do begin
        L3:=L1+L2;
        if BUF^[L3]=0 then begin
          inc(NullCount); inc(C0);
        end else begin
          if BUF^[L3]<$40 then inc(C0) else
          if BUF^[L3]<$80 then inc(C1) else
          if BUF^[L3]<$c0 then inc(C2) else inc(C3);
          inc(Average,BUF^[L3]);
        end;
      end;
      Average:=Average div $0020;
      if ABS(C2-C3)>Diff then Diff:=ABS(C2-C3);
      if ABS(C1-C3)>Diff then Diff:=ABS(C1-C3);
      if ABS(C0-C3)>Diff then Diff:=ABS(C0-C3);
      if ABS(C1-C2)>Diff then Diff:=ABS(C1-C2);
      if ABS(C0-C2)>Diff then Diff:=ABS(C0-C2);
      if ABS(C0-C1)>Diff then Diff:=ABS(C0-C1);
  {    write(T,'$',hexa(L1,4),': AVG $',hexa(Average,2),' / NUL $',hexa(NullCount,2),' / C0-C3 ');
      writeln(T,hexa(C0,2),'/',hexa(C1,2),'/',hexa(C2,2),'/',hexa(C3,2),' / DIF $',hexa(Diff,2));}
      if (Diff>$0f) and (NullCount>$01) and ((Average<$40) or (Average>$c0)) then R1:=L1;
      dec(L1,$0020);
    end;
    if finetune then begin
      L1:=R1+$003f;
      while ((BUF^[L1]<>0) or (BUF^[L1+1]<>0)) and (L1>R1) and (L1>0) do dec(L1);
      inc(L1,2);
      while (BUF^[L1]<$80) and (L1<$bfff) do inc(L1);
      while (BUF^[L1]>$00) and (L1>$0000) do dec(L1);
      {L1}
    end else L1:=R1;
    if (L1<$1000) or (L1>$8000) or (BUF^[0]<>$4d) or (BUF^[1]<>$5a) then begin
      ArchiveVars.ApprArcResult:=$ff;
      ArchiveVars.ApprArcOfs:=$0000;
    end else begin
      ArchiveVars.ApprArcResult:=$00;
      ArchiveVars.ApprArcOfs:=L1;
    end;
    close(F);
  end else ArchiveVars.ApprArcResult:=$ff;
  dispose(BUF);
end;

procedure RealArc(S1:string);
var Pos:longint;
begin
  with ArchiveVars do begin
    if useroffset=-1 then begin
      write('  Calculating approximated packed data offset ..................... ');
      ApprArc(S1);
    end else begin
      ApprArcOfs:=useroffset;
      ApprArcResult:=$00;
      write('  Userdefined offset given by parameter ........................... ');
    end;
    RealArcResult:=$ff;
    if ApprArcResult=$00 then begin
      writeln('$',Hexa(ApprArcOfs,8));
      if rollback>0 then begin
        write('  Userdefined rollback given by parameter ......................... ');
        writeln('$',Hexa(RollBack,8));
      end;
      write('  Calculating exact packed data offset ............................ ');
      for Pos:=$0000-rollback to $05ff do begin
        TestInflate(S1,ApprArcOfs+Pos);
        if TestInflateResult<$fe then begin
          RealArcResult:=TestInflateResult;
          RealArcOfs:=Pos+ApprArcOfs;
          Pos:=$05ff;
        end;
      end;
      if RealArcResult=$ff then writeln('failed!') else writeln('$',Hexa(RealArcOfs,8));
    end else writeln('failed!');
  end;
end;

procedure HWUNTitle;
var Pos:byte;
    v:word;
begin
  for Pos:=$00 to $4e do write(''); writeln;
  write  (' HWUN v');
  v:=HWUN_Version shr $0c;
  write  (hexa(v,1),'.');
  v:=HWUN_Version and $fff;
  write  (hexa(v,3));
  writeln(' (Heuristic Wise UNpacker, ',DateStr,')  (c) by Jgermeister Markus');
  for Pos:=$00 to $4e do write(''); writeln;
end;

procedure IncreaseFileName(var FileName:string);
var b:byte;
begin
  b:=byte(FileName[0]);
  while (FileName[b]='9') do begin
    FileName[b]:='0';
    dec(b);
  end;
  inc(FileName[b]);
end;

function ReadLongInt(S1:string; Offset:longint):longint;
var F:file;
    L:longint;
begin
  assign(F,S1);
  reset(F,1);
  seek(F,Offset);
  blockread(F,L,4);
  close(F);
  ReadLongInt:=L;
end;

procedure ExtractFiles(S1:string);
var FileName:string;
    FilePos:longint;
    Pos:longint;
    CSize,USize:longint;
    Enough:boolean;
    PKZipFormat,PKZipEnd:boolean;
    PKZipEnding:longint;
    ZipNextFileStart:longint;
    DumpFile:file;
begin
  RealArc(S1);
  PKZipFormat:=FALSE;
  PKZipEnd:=FALSE;
  if ArchiveVars.RealArcResult<$ff then begin
    FileName:='WISE0000';
    assign(DumpFile,FileName);
    rewrite(DumpFile,1);
    FilePos:=ArchiveVars.RealArcOfs;
    Enough:=FALSE;
    Repeat
      IncreaseFileName(FileName);
      InitializeInflate(S1,FileName,FilePos);
      if InflateVars.InflateResult=$00 then begin
        write('  Expanding ',FileName,', offset $',hexa(FilePos,8),', ');
        ExecuteInflate;
        if InflateVars.InflateResult=$00 then begin
          blockwrite(DumpFile,FileName[1],8);
          if PkZipFormat then blockwrite(DumpFile,PkZipEnding,4)
                         else blockwrite(DumpFile,FilePos,4);
          writeln('crc32 $',hexa(InflateVars.CRC32,8),', filelength $',hexa(InflateVars.F2Length,8));
          FilePos:=InflateVars.F1Pos;
          Enough:=TRUE;
          If not PkZipFormat then begin
            Pos:=$0010;
            if FilePos+$04+Pos>InflateVars.F1Length then Pos:=InflateVars.F1Length-FilePos-$04;
            while (Enough) and (Pos>-$0100) do begin
              if ReadLongInt(S1,FilePos+Pos)=InflateVars.CRC32 then Enough:=FALSE;
              Dec(Pos);
            end;
          end;
          if (Enough) then begin
            Pos:=$0010;
            if FilePos+$04+Pos>InflateVars.F1Length then Pos:=InflateVars.F1Length-FilePos-$04;
            while (Enough) and (Pos>-$0100) do begin
              if (ReadLongInt(S1,FilePos+Pos)=$04034b50) then begin
                Enough:=FALSE;
                PkZipFormat:=TRUE;
              end else begin
                if (ReadLongInt(S1,FilePos+Pos)=$02014b50) then begin
                  Enough:=FALSE;
                  PkzipEnd:=TRUE;
                  PKZipFormat:=TRUE;
                end;
              end;
              Dec(Pos);
              if not Enough then begin
                PkZipEnding:=FilePos+Pos+$01;
                FilePos:=FilePos+$1a;
                FilePos:=FilePos+ReadLongInt(S1,PkZipEnding+$1a) and $ffff;
              end;
            end;
          end;
          if (Enough) then writeln('  Could not find matching CRC32! Maybe archive is in PKZIP format?')
                      else begin
                        FilePos:=FilePos+Pos+$05;
                        if not PkZipFormat then blockwrite(DumpFile,FilePos,4)
                                           else blockwrite(DumpFile,PkZipEnding,4);
                      end;
        end else begin
          Enough:=TRUE;
          if PkZipFormat then writeln('PKZip central directory found')
                         else writeln('possible extra data at archive end');
          erase(InflateVars.F2);
          writeln('  Archive end reached. All files extracted successfully!');
        end;
        if (not Enough) and (FilePos+$10+Pos>=InflateVars.F1Length) then begin
          Enough:=TRUE;
          FilePos:=InflateVars.F1Length;
          writeln('  Archive end reached. All files extracted successfully!');
        end;
      end else writeln('  Could not inflate next file! Is archive corrupt or incomplete?');
    Until (Enough);
    close(DumpFile);
  end else writeln('  File does not seem to contain a WISE archive - try Veit''s E_WISE!');
end;

procedure GenerateRenamer;
var DumpFile,ScriptFile:file;
    FileName,NewName,ScriptName:string;
    ShitFile:file;
    TempStart,TempLen,TempEnd,FileStart,FileLen,FileEnd:longint;
    ArcLength,ArcStart,ScriptSize:longint;
    FirstFound:boolean;
    Test:boolean;
    Error:boolean;
    Buffer:^tAOB;
    Pos,Post,Postt:longint;
    BufferSize:longint;
    Minimum:longint;
    Time,Date:word;
    ControlByte:byte;
    B1,B2:byte;
    Result:boolean;
    Dummy:longint;
    FixedName:string;
begin
  assign(DumpFile,'WISE0000');
 {$I-} reset(DumpFile,1); {$I+}
  if IoResult<>0 then begin
    ExitProc:=SaveExit;
    Halt(1);
  end;
  FileName[0]:=#8;
  ScriptName[0]:=#8;
  Test:=FALSE;
  repeat
    blockread(DumpFile,ScriptName[1],8);
    blockread(DumpFile,FileStart,4);
    blockread(DumpFile,FileEnd,4);
    assign(ScriptFile,ScriptName);
    reset(ScriptFile,1);
    BufferSize:=filesize(ScriptFile);
    if BufferSize>$8000 then BufferSize:=$8000;
    getmem(Buffer,BufferSize);
    blockread(ScriptFile,Buffer^,BufferSize);
    close(ScriptFile);
    Pos:=$00;
    while (Pos<BufferSize) and (not Test) do begin
      inc(Pos);
      Test:=TRUE;
      if Test then Test:=Buffer^[Pos+$00]=$25{"%"};
      if Test then Test:=Buffer^[Pos+$01]<>$5c{"\"};
      if Test then begin
        Post:=$01;
        while (Post+Pos<BufferSize) and (Buffer^[Pos+Post]<>$25) and (Post<$10) do inc(Post);
        Test:=(Post<$10) and (Buffer^[Pos+Post+$01]=$5c{"\"});
      end;
    end;
    freemem(Buffer,BufferSize);
  until eof(DumpFile) or Test;
  write('  Script is ',ScriptName,', renaming and moving files (may take a while!) ');

  seek(DumpFile,0);
  BufferSize:=filesize(DumpFile);
  getmem(Buffer,BufferSize);
  blockread(DumpFile,Buffer^,BufferSize);
  close(DumpFile);

{ Dumpfile read to Buffer^, correct ScriptFile opened }

  reset(ScriptFile,1);
  Pos:=$00;
  NewName:='';
  Minimum:=$00000000;
  FileName:='xxxxxxxx';
  FirstFound:=FALSE;
  while Pos+$02<fileSize(ScriptFile) do begin
    seek(ScriptFile,Pos);
    blockread(ScriptFile,ControlByte,1);
    if ControlByte=$25 then begin
      blockread(ScriptFile,ControlByte,1);
      if (ControlByte<>$5c) then begin
{        inc(waitind);
        write(waitstr[(waitind div $02) mod $04]); gotoxy(wherex-1,wherey);}
        NewName:='';
        Test:=FALSE;
        repeat
          NewName:=NewName+chr(ControlByte);
          blockread(ScriptFile,ControlByte,1);
          if copy(NewName,length(NewName)-1,2)='%\' then Test:=TRUE;
        until (ControlByte in [$7f,$00]) or (filepos(ScriptFile)=filesize(ScriptFile));
        if (Test) and (Pos>=$28) then begin
          seek(ScriptFile,Pos-$28);
          blockread(ScriptFile,TempStart,4);
          blockread(ScriptFile,TempEnd,4);
          blockread(ScriptFile,Date,2);
          blockread(ScriptFile,Time,2);
          TempLen:=TempEnd-TempStart;
          if (TempStart-Minimum<$100000) and (TempStart<TempEnd) and (TempStart>=Minimum) then begin
            if not FirstFound then begin
              Post:=$0000;
              Error:=FALSE;
              repeat
                move(Buffer^[Post+$8],FileStart,4);
                move(Buffer^[Post+$c],FileEnd,4);
                FileLen:=FileEnd-FileStart;
                inc(Post,$10);
              until (FileLen=TempLen) or (Post>=BufferSize);
              if (Post<BufferSize) and (NewName[byte(NewName[0])]<>'%') then begin
                FirstFound:=TRUE;
                ArcStart:=FileStart-TempStart;
                move(Buffer^[Post-$10],FileName[1],8);
              end else FirstFound:=FALSE;
            end else begin
              repeat
                move(Buffer^[Post+$8],FileStart,4);
                move(Buffer^[Post+$c],FileEnd,4);
                move(Buffer^[Post+$0],FileName[1],8);
                FileLen:=FileEnd-FileStart;
                inc(Post,$10);
              until ((FileStart=TempStart+ArcStart) and (FileEnd=TempEnd+ArcStart)) or (Post>=BufferSize);
              Error:=(FileStart<>TempStart+ArcStart) or (FileEnd<>TempEnd+ArcStart);
            end;
            if (FirstFound) and (not Error) then begin
              FixedName:='';
              for ControlByte:=1 to length(NewName) do begin
                if NewName[ControlByte]='\' then begin
                 {$I-} MkDir(FixedName); Dummy:=IoResult; {$I+}
                end;
                if NewName[ControlByte]<>'%' then FixedName:=FixedName+NewName[ControlByte];
              end;
{              writeln;
              write(Date and $1f:2,'.',Date shr $05 and $f:2,'.',Date shr $09+1980);
              write(' ',Time shr $0b:2,':',Time shr $05 and $3f:2,'.',Time and $1f:2);
              write(' ',FileName,' -> ',FixedName);}
              writeln;
              write('  ',filename,' => ',fixedname);
              repeat
                if dispdebug then writeln;
                if dispdebug then writeln('--------------',filename,'--------------');
                if dispdebug then writeln('1. Assigning file "',filename,'"...');
                assign(shitfile,filename);
                if dispdebug then writeln('2. Renaming/moving to "',fixedname,'"...');
                {$I-} rename(shitfile,fixedname); {$I+}
                Dummy:=IoResult;
                Result:=Dummy=0;
                if dispdebug then write('3. Result code was $',hexa(dummy,4),'...');
                if Result then begin
                  if dispdebug then writeln(' => no error');
                  filemode:=$11;
                  if dispdebug then writeln('4. Opening file "',fixedname,'" with filemode $0011...');
                  assign(shitfile,fixedname);
                  reset(shitfile,1);
                  if dispdebug then writeln('5. Timestamping attempt...');
                 {$I+} setftime(shitfile,longint(Date)*$10000+longint(Time)); {$I-}
                  close(shitfile);
                  if dispdebug then writeln('6. ----EVERYTHING-OKAY----');
                 { W95SetTimeDate(FixedName,Date,Time);}
                end else if dispdebug then writeln;
                NewName:='';
                ControlByte:=length(FixedName);
                while (FixedName[ControlByte]<>'.') and (ControlByte>$00) do dec(ControlByte);
                if ControlByte=$01 then FixedName:=FixedName+'.!' else begin
                  FixedName:=copy(FixedName,1,ControlByte)+'!.'+copy(FixedName,ControlByte+1,length(FixedName)-ControlByte);
                end;
              until (Result) or (length(FixedName)>$fb);
              Minimum:=TempEnd;
            end;
          end;
        end;
      end;
    end;
    inc(Pos);
  end;

  freemem(Buffer,Buffersize);
  close(ScriptFile);
  writeln;
  writeln('  All files renamed successfully, HWUN says Goodbye!');
end;

var Win:word;
    EXEstring:string;
    b:byte;
    f:file;
    options:string;
begin
  SaveExit:=ExitProc;
  ExitProc:=@ExitProcedure;
  FileMode:=0;
  HWUNTitle;
  if paramcount=0 then begin
    writeln(' Usage: HWUN <wisefile.exe> [options (case-insensitive)]');
    writeln;
    writeln(' Options: Bxxxx - rollback xxxx (hex) bytes from approximated offset');
    writeln('          Uxxxx - take xxxx instead of approximated offset');
    writeln('          R     - disable renaming/moving of WISExxxx files');
    writeln('          A     - offset approximation without finetuning');
    writeln;
    writeln(' Example: HWUN install.exe rb0020 -> 32 bytes rollback without renaming');
    writeln('          HWUN someprg.exe U377a  -> start at offset $0000377a');
    writeln('          HWUN patch11.exe a      -> do the task without finetuning');
    writeln;
    writeln(' Contact: jaegermeister.markus@gmx.de, http://jmeister.cjb.net');
  end else begin
    ExeString:=paramstr(1);
    assign(f,ExeString);
    {$I-} reset(f,1); {$I+}
    if IoResult<>0 then begin
      writeln('  File passed by parameter was not found!');
      ExitProc:=SaveExit;
      halt(254);
    end else close(f);
    rollback:=0;
    useroffset:=-1;
    finetune:=true;
    renaming:=true;
    if paramcount=2 then begin
      options:=paramstr(2);
      b:=1;
      while b<=length(options) do begin
        if upcase(options[b])='B' then begin
          rollback:=deci(copy(options,b+1,4));
          inc(b,4);
        end else if upcase(options[b])='U' then begin
          useroffset:=deci(copy(options,b+1,4));
          inc(b,4);
        end else if upcase(options[b])='R' then begin
          renaming:=FALSE;
        end else if upcase(options[b])='A' then begin
          finetune:=FALSE;
        end;
        inc(b);
      end;
    end;
    ExtractFiles(ExeString);
    if renaming then GenerateRenamer else writeln('  Renaming disabled, Goodbye!');
  end;
end.
